<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
 <HEAD>
  <TITLE>
   mobile map by petschge.de &amp; lusiardi.de
  </TITLE>
  <META name="author" content="Petschge, n0ob">
  <META name="date" content="2008-12-11">
  <META name="robots" content="index">
  <META http-equiv="content-type" content="text/html; charset=iso-8859-1">
  <META name="generator" content="vim 7.0">
  <LINK rel="shortcut icon" href="/favicon.ico">
  <LINK rel="stylesheet" type="text/css" href="style.css">
 </HEAD>
 <BODY>
<?php
	include("config.php");
	include("func.php");

	$res = getRes();
	$width = $res["width"];
	$height = $res["height"];
	$border = $res["border"];

	$bugid = getValueFromRequest("bug", "0");
	$lat = getValueFromRequest("lat", $defaultlat);
	$lon = getValueFromRequest("lon", $defaultlon);
	$zoom = getValueFromRequest("zoom", $defaultzoom);
	$gpx = getValueFromRequest("gpx", "");
	$trackcolor = getValueFromRequest("trackcolor", "");
	$layer = getValueFromRequest("layer", "B00FFF");
	$layerArray = parseLayer($layer);
	if($zoom < 9) {
		$layerArray["osb"] = false;
	}
	$layer = layerToString($layerArray);

	$default = array("width" => $width, "height" => $height, "border" => $border, "lat" => $lat, "lon" => $lon, "zoom" => $zoom, "layer" => $layer);
	if($gpx != "") {
		$default["gpx"] = $gpx;
	}
	if($trackcolor != "") {
		$default["trackcolor"] = $trackcolor;
	}

	$up = clipZoom(1, $zoom - 1, 16);
	$down = clipZoom(1, $zoom + 1, 16);
	// 2 x border for scrolling. image split into 3x3
	$w = ($width- 2*$border)/3;
	$h = ($height- 2*$border)/3;

	// how wide and high is a tile in degres
	$dlon = 360/pow(2, $zoom);
	$dlat = 360 * cos($lat * pi() / 180)/pow(2, $zoom);

	$north = $lat + $h * $dlat / 256;
	$south = $lat - $h * $dlat / 256;
	$east = $lon + $w * $dlon / 256;
	$west = $lon - $w * $dlon / 256;

	$hlbug = array();
	if($layerArray["osb"] || $layerArray["links"]) {
		for($i = 1; $i <= 3; $i++) {
			for($j = 1; $j <= 3; $j++) {
				$nb = $lat + (2-$i+0.5)*$h*$dlat / 256;
				$sb = $lat + (2-$i-0.5)*$h*$dlat / 256;
				$wb = $lon + ($j-2-0.5)*$w*$dlon / 256;
				$eb = $lon + ($j-2+0.5)*$w*$dlon / 256;
				$mapstring = "<MAP name=\"osb_{$j}_{$i}\">\n";

				$points = array();
				if($layerArray["osb"]) {
					$points = array_merge($points, getBugs($nb, $sb, $wb, $eb));
				}
				if($layerArray["links"]) {
					$points = array_merge($points, getLinks($nb, $sb, $wb, $eb));
				}

				while(list($key, $point) = each($points)) {
					if(($sb <= $point[2]) && ($point[2] <= $nb) && ($wb <= $point[1]) && ($point[1] <= $eb)) {
						$x = (getTileX($point[1], $zoom) - getTileX($wb, $zoom)) * 256;
						$y = (getTileY($point[2], $zoom) - getTileY($nb, $zoom)) * 256;
						$r = 4;
						if($point["type"] == "bug") {
							$mapstring .= "<AREA shape=\"circle\" href=\"map.php?".toUrl(cow($default, array("bug" => $point[0], "lon" => $point[1], "lat" => $point[2], "zoom" => $down)))."\" coords=\"$x,$y,$r\" alt=\"{$point[0]}\" title=\"{$point[0]}\">\n";
						} else {
							$mapstring .= "<AREA shape=\"circle\" href=\"{$point[3]}\" coords=\"$x,$y,$r\" alt=\"{$point[0]}\" title=\"{$point[0]}\">\n";
						}
						if($point[0] ==  $bugid) {
							$hlbug = $point;
						}
					}
				}
				$mapstring .= "</MAP>\n";
				// empty maps are invalid HTML and a waste of bandwidth
				if(strlen($mapstring) > strlen("<MAP name=\"osb_1_1\">\n</MAP>\n")) {
					echo $mapstring;
				}
			}
		}
	}

	// layout grid with borders. note that whitespace breaks the rendering on my palm treo
	for($i = 0; $i <= 4; $i++) {
		for($j = 0; $j <= 4; $j++) {
			if($i == 0) {
				if($j < 1 || $j > 3) {
					echo "<IMG src=\"rand.php?width=$border&amp;height=$border&amp;dir=none\" width=\"$border\" height=\"$border\" alt=\"corner\">";
				} else {
					echo "<A href=\"map.php?".toUrl(cow($default, array("lat" => $north)))."\">";
					echo "<IMG src=\"rand.php?width=$w&amp;height=$border&amp;dir=up\" border=\"0\" width=\"$w\" height=\"$border\" alt=\"up\">";
					echo "</A>";
				}
			} else if ($i < 4) {
				if($j == 0) {
					echo "<A href=\"map.php?".toUrl(cow($default, array("lon" => $west)))."\">";
					echo "<IMG src=\"rand.php?width=$border&amp;height=$h&amp;dir=left\" border=\"0\" width=\"$border\" height=\"$h\" alt=\"left\">";
					echo "</A>";
				} else if ($j < 4) {
					$link = $default;
					$link["zoom"] = $down;
					if($j == 1) {
						$link["lon"] = $west;
					} else if ($j == 3) {
						$link["lon"] = $east;
					}
					if($i == 1) {
						$link["lat"] = $north;
					} else if ($i == 3){
						$link["lat"] = $south;
					}
					if($layerArray["osb"] || $layerArray["links"] ) {
						// perhaps we should only set usemap if that map is not empty...
						echo "<IMG src=\"tile.php?width=$w&amp;height=$h&amp;lat=$lat&amp;lon=$lon&amp;zoom=$zoom&amp;py=$i&amp;px=$j&amp;layer=$layer&amp;gpx=$gpx&amp;trackcolor=$trackcolor\" alt=\"map_${i}_${j}\" border=\"0\" width=\"$w\" height=\"$h\"  usemap=\"#osb_{$j}_{$i}\">";
					} else {
						echo "<A href=\"map.php?".toUrl($link)."\">";
						echo "<IMG src=\"tile.php?width=$w&amp;height=$h&amp;lat=$lat&amp;lon=$lon&amp;zoom=$zoom&amp;py=$i&amp;px=$j&amp;layer=$layer&amp;gpx=$gpx&amp;trackcolor=$trackcolor\" alt=\"map_${i}_${j}\" border=\"0\" width=\"$w\" height=\"$h\">";
						echo "</A>";
					}
				} else {
					echo "<A href=\"map.php?".toUrl(cow($default, array("lon" => $east)))."\">";
					echo "<IMG src=\"rand.php?width=$border&amp;height=$h&amp;dir=right\" border=\"0\" width=\"$border\" height=\"$h\" alt=\"right\">";
					echo "</A>";
				}
			} else {
				if($j < 1 || $j > 3) {
					echo "<IMG src=\"rand.php?width=$border&amp;height=$border&amp;dir=none\" width=\"$border\" height=\"$border\" alt=\"corner\">";
				} else {
					echo "<A href=\"map.php?".toUrl(cow($default, array("lat" => $south)))."\">";
					echo "<IMG src=\"rand.php?width=$w&amp;height=$border&amp;dir=down\" border=\"0\" width=\"$w\" height=\"$border\" alt=\"down\">";
					echo "</A>";
				}
			}
		}
		echo "<BR>";
	}

	// div to simulate mobile display behaviour
	echo "<div style='width:$width;'>";

	// buttons for zoom and permalink
	$zoomsize = max($border, $minButtonSize);
	// map tiles are rounded down to int. three of those plus twice the border
	// are the actuall over all width of the map display. we use that for the
	// permalink, the search and the two zoombutton left and right
	$totalwidth = 3*((int)($w)) + 2*$border - 2*$zoomsize;
	$searchlinksize = $totalwidth/2;
	$permalinksize = $totalwidth - $searchlinksize;

	echo "<a href='map.php?".toUrl(cow($default, array("zoom" => $down)))."'>";
	echo "<img border='0' width='$zoomsize' height='$zoomsize' src='./button.php?width=$zoomsize&amp;height=$zoomsize&amp;text=%2B' alt='%2B'/>";
	echo "</a>";
	echo "<a href='map.php?".toUrl($default)."'>";
	echo "<img border='0' width='$permalinksize' height='$zoomsize' src='./button.php?width=$permalinksize&amp;height=$zoomsize&amp;text=Permalink' />";
	echo "</a>";
	echo "<a href='search.php?".toUrl($default)."'>";
	echo "<img border='0' width='$searchlinksize' height='$zoomsize' src='./button.php?width=$searchlinksize&amp;height=$zoomsize&amp;text=Search' />";
	echo "</a>";
	echo "<a href='map.php?".toUrl(cow($default, array("zoom" => $up)))."'>";
	echo "<img border='0' width='$zoomsize' height='$zoomsize' src='./button.php?width=$zoomsize&amp;height=$zoomsize&amp;text=-' alt='-'/>";
	echo "</a>";
	echo "<br />";

	// show bug details
	if(count($hlbug) != 0) {
		echo "View bug #{$hlbug[0]}:<BR>\n";
		$parts=explode("<hr />", $hlbug[3]);
		echo "<UL>\n";
		while(list($key, $text) = each($parts)) {
			// decode to convert &quot to ", encode to convert all special chars
			echo "<LI>".htmlentities(html_entity_decode($text, ENT_COMPAT, "UTF-8") , ENT_NOQUOTES, "UTF-8")."</LI>\n";
		}
		echo "</UL>\n";
		if($hlbug[4] == 0) {
			echo "The bug is still open<BR>\n";
			echo "<A href=\"addcomment.php?".toURL(cow($default, array("bug" => $hlbug[0])))."\">Add comment</A><BR>\n";
			echo "<A href=\"closebug.php?".toURL(cow($default, array("bug" => $hlbug[0])))."\">Close this bug</A><BR>\n";
		} else {
			echo "The bug is closed<BR>\n";
		}
		echo "<BR>\n";
	}

	while(list($key, $base) = each($baselayers)) {
		if($base != $layerArray["base"]) {
			$newbasestring = layerToString(cow($layerArray, array("base" => $base)));
			echo "<A href=\"map.php?".toUrl(cow($default, array("layer" => $newbasestring)))."\">$base</A>\n";
		}
	}

	while(list($key, $overlay) = each($overlays)) {
		if($layerArray[$overlay]) {
			$newoverlaystring = layerToString(cow($layerArray, array($overlay => false)));
			echo "<A href=\"map.php?".toUrl(cow($default, array("layer" => $newoverlaystring)))."\">disable $overlay</A>\n";
		} else {
			$newoverlaystring = layerToString(cow($layerArray, array($overlay => true)));
			echo "<A href=\"map.php?".toUrl(cow($default, array("layer" => $newoverlaystring)))."\">$overlay</A>\n";
		}
	}
	echo "<BR><BR>\n";

	if($default["gpx"] != "") {
		echo "<FORM action=\"map.php\" method=\"get\">\n";
		while(list($key, $val) = each($default)) {
			if($key != "trackcolor") {
				echo "<INPUT type=\"hidden\" name=\"$key\" value=\"$val\">\n";
			}
		}
		echo "<SELECT name=\"trackcolor\" size=\"1\">\n";
		reset($colors);
		while(list($name, $hex) = each($colors)) {
			echo "<OPTION value=\"$hex\">$name</OPTION>\n";
		}
		echo "</SELECT>\n";
		echo "<INPUT type=\"submit\" value=\"Change color\">\n";
		echo "</FORM>\n";
	}
	echo "<A href=\"addbug.php?".toUrl($default)."\">Error in the map?</A><BR>\n";
	echo "<A href=\"index.php\">Wrong screen size?</A><BR>\n";

	echo "</div>";
?>
 </BODY>
</HTML>
