<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<head>
	<title>mobile map by petschge.de &amp; lusiardi.de</title>
	<meta http-equiv="content-type"	content="text/html;charset=utf-8" />
	<meta http-equiv="Content-Style-Type" content="text/css" />
	<link rel="shortcut icon" href="/favicon.ico" />
	<link rel="stylesheet" type="text/css" href="style.css" />
</head>

<body>

<?php
	include("func.php");

	$resolutionData = getRes();
	$query = getValueFromRequest("query", "");
	$wasSend = getValueFromRequest("wasSend", "false");

?>
<div class="searchBox">
	<form action="" method="get">
		<p style="display:none;">
			<input type="hidden" name="wasSend" value="true"/>
			<input type="hidden" name="width" value="<?php echo $resolutionData["width"] ?>"/>
			<input type="hidden" name="height" value="<?php echo $resolutionData["height"] ?>"/>
			<input type="hidden" name="border" value="<?php echo $resolutionData["border"] ?>"/>
		</p>
		<div class="searchfield">
			Search for: <input type="text" name="query" value="<?php echo $query ?>"/> <input type="submit" value="search"/>
		</div>
	</form>
</div>
<?php
	if($wasSend != "false") {
		$dom = new DOMDocument;
		if(@$dom->load("http://gazetteer.openstreetmap.org/namefinder/search.xml?find=".urlencode($query)."&amp;max=20") == false) {
			echo "search is broken";
		} else {
			$xpath = new DOMXPath($dom);

			$namedElements = $xpath->query('/searchresults/named');
			foreach($namedElements as $namedElement) {
				$category =  getAttributeFromElement($namedElement, "info");
				$name = getAttributeFromElement($namedElement, "name");
				$is_in = getAttributeFromElement($namedElement, "is_in");

				$params = array (
							"width" => $resolutionData["width"],
							"height" => $resolutionData["height"],
							"border" => $resolutionData["border"],
							"lat" => getAttributeFromElement($namedElement, "lat"),
							"lon" => getAttributeFromElement($namedElement, "lon"),
							"zoom" => getAttributeFromElement($namedElement, "zoom"),
					);

				echo "<div class='searchResult'>";
				echo "<p>";
				echo "$category named <a href='map.php?".toURL($params)."'>$name</a> $is_in";
				echo "</p>";
				echo "<p>nearby places:</p>";

				$nearbyPlaces =  $xpath->query('.//nearestplaces/named', $namedElement);
				foreach($nearbyPlaces as $nearbyPlace) {
					$name = getAttributeFromElement($nearbyPlace, "name");

					$params = array (
								"width" => $resolutionData["width"],
								"height" => $resolutionData["height"],
								"border" => $resolutionData["border"],
								"lat" => getAttributeFromElement($nearbyPlace, "lat"),
								"lon" => getAttributeFromElement($nearbyPlace, "lon"),
								"zoom" => getAttributeFromElement($nearbyPlace, "zoom"),
						);
					echo "<p>";
					echo "- <a href='map.php?".toURL($params)."'>$name</a>";
					echo "</p>";
				}

				echo "</div>";
			}
		}
	}
?>
</body>
</html>
